<?php

/*
		Généalogik
		
        Class for table : place.

        07/03/2021 10:45

        lvardon@laposte.net - 2021
        
        Licence libre

        Usage examples :

        <?php

            include_once("classdir/dbconnect.php);
            include_once("classdir/class_place.php);

            // Class instance
            $myplace = place( $db );

            // Select all reccords :
            $results = $myplace->selectAll();
            foreach($results as $row) {
                print_r($row);
            } 

            // Select reccord #12 :
            $id = 12;
            $row = $myplace->select($id);
            print_r($row);

        ?>

*/
class _place {
      
    public $db;
    public $lasterror="";
    public $lastInsertId=-1;
    public $count = 0;
  
    /*
        Initialise object with dbHanler.
                
    */    
    function __construct( $db ) {
        $this->db = $db;
    }

    /*
        Select one reccord from place.
        
        parameters : $id (reccord id).
        return : associative array of reccord.
    */
    function select($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.icon as 'a.icon',
			a.adress1 as 'a.adress1',
			a.adress2 as 'a.adress2',
			a.zipcode as 'a.zipcode',
			a.city as 'a.city',
			a.cityinsee as 'a.cityinsee',
			a.country as 'a.country',
			a.url as 'a.url',
			a.gpslat as 'a.gpslat',
			a.gpslon as 'a.gpslon',
			a.datecreated as 'a.datecreated'


		from place a 

		where a.id = :id; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }

    function selectPrev($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.icon as 'a.icon',
			a.adress1 as 'a.adress1',
			a.adress2 as 'a.adress2',
			a.zipcode as 'a.zipcode',
			a.city as 'a.city',
			a.cityinsee as 'a.cityinsee',
			a.country as 'a.country',
			a.url as 'a.url',
			a.gpslat as 'a.gpslat',
			a.gpslon as 'a.gpslon',
			a.datecreated as 'a.datecreated'


		from place a 

		where a.id =  (SELECT id FROM place WHERE id < :id ORDER BY id DESC LIMIT 1) ; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }


    function selectNext($id) {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.icon as 'a.icon',
			a.adress1 as 'a.adress1',
			a.adress2 as 'a.adress2',
			a.zipcode as 'a.zipcode',
			a.city as 'a.city',
			a.cityinsee as 'a.cityinsee',
			a.country as 'a.country',
			a.url as 'a.url',
			a.gpslat as 'a.gpslat',
			a.gpslon as 'a.gpslon',
			a.datecreated as 'a.datecreated'


		from place a 

		where a.id =  (SELECT id FROM place WHERE id > :id ORDER BY id ASC LIMIT 1) ; 
			";

        try {        		

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$idkeyname.')';
            return false;
        }
    }

    /*
        Select all reccords from place  (with default order).
        
        parameters : None
        return : associative array of reccords.
    */
    function selectAll() {

        $this->lasterror="";

        $sqlSt="
		select       
			a.id as 'a.id',  
			a.name as 'a.name',
			a.description as 'a.description',
			a.private as 'a.private',
			a.icon as 'a.icon',
			a.adress1 as 'a.adress1',
			a.adress2 as 'a.adress2',
			a.zipcode as 'a.zipcode',
			a.city as 'a.city',
			a.cityinsee as 'a.cityinsee',
			a.country as 'a.country',
			a.url as 'a.url',
			a.gpslat as 'a.gpslat',
			a.gpslon as 'a.gpslon',
			a.datecreated as 'a.datecreated'


		from place a 

		;    
                ";

        try {        

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC);           
            return $results;

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage();
            $this->count = 0;
            return false;
        }
    }

    /*
        Update place 
        
        parameters : $id (reccord id) and fields list values.
        return : True if no error.
    */
    function update( $id, $name,$description,$private,$icon,$adress1,$adress2,$zipcode,$city,$cityinsee,$country,$url,$gpslat,$gpslon,$datecreated ) {

        $this->lasterror="";        

		if ($name == '') $name = null;
		if ($description == '') $description = null;
		if ($private == '') $private = null;
		if ($icon == '') $icon = null;
		if ($adress1 == '') $adress1 = null;
		if ($adress2 == '') $adress2 = null;
		if ($zipcode == '') $zipcode = null;
		if ($city == '') $city = null;
		if ($cityinsee == '') $cityinsee = null;
		if ($country == '') $country = null;
		if ($url == '') $url = null;
		if ($gpslat == '') $gpslat = null;
		if ($gpslon == '') $gpslon = null;
		if ($datecreated == '') $datecreated = null;
		

        if ($this->checkValue( array( 
		$name => '',
		$description => '',
		$private => '',
		$icon => '',
		$adress1 => '',
		$adress2 => '',
		$zipcode => '',
		$city => '',
		$cityinsee => '',
		$country => '',
		$url => '',
		$gpslat => '',
		$gpslon => '',
		$datecreated => ''

) ) == false )
        {
            $this->lasterror="Check fields false";        
            return false;
        }

        $sqlSt="
		update place set
			name = :name,
			description = :description,
			private = :private,
			icon = :icon,
			adress1 = :adress1,
			adress2 = :adress2,
			zipcode = :zipcode,
			city = :city,
			cityinsee = :cityinsee,
			country = :country,
			url = :url,
			gpslat = :gpslat,
			gpslon = :gpslon,
			datecreated = :datecreated

		where id = :id; 
            ";

        try {        
            
            $stmt = $this->db->prepare($sqlSt);
            
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);

			$stmt->bindParam(':name', $name, PDO::PARAM_STR); 
			$stmt->bindParam(':description', $description, PDO::PARAM_STR); 
			$stmt->bindParam(':private', $private, PDO::PARAM_INT); 
			$stmt->bindParam(':icon', $icon, PDO::PARAM_STR); 
			$stmt->bindParam(':adress1', $adress1, PDO::PARAM_STR); 
			$stmt->bindParam(':adress2', $adress2, PDO::PARAM_STR); 
			$stmt->bindParam(':zipcode', $zipcode, PDO::PARAM_STR); 
			$stmt->bindParam(':city', $city, PDO::PARAM_STR); 
			$stmt->bindParam(':cityinsee', $cityinsee, PDO::PARAM_INT); 
			$stmt->bindParam(':country', $country, PDO::PARAM_STR); 
			$stmt->bindParam(':url', $url, PDO::PARAM_STR); 
			$stmt->bindParam(':gpslat', $gpslat, PDO::PARAM_STR); 
			$stmt->bindParam(':gpslon', $gpslon, PDO::PARAM_STR); 
			$stmt->bindParam(':datecreated', $datecreated, PDO::PARAM_STR); 
 
            $stmt->execute();             
            
            if ($stmt->rowCount() == 0) {
				$this->lasterror = 'Erreur Sql update '.'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>icon</b> = [$icon],<b>adress1</b> = [$adress1],<b>adress2</b> = [$adress2],<b>zipcode</b> = [$zipcode],<b>city</b> = [$city],<b>cityinsee</b> = [$cityinsee],<b>country</b> = [$country],<b>url</b> = [$url],<b>gpslat</b> = [$gpslat],<b>gpslon</b> = [$gpslon],<b>datecreated</b> = [$datecreated]";
				
				return false;
			}   
			         
            return true;

        } catch (Exception $e) {            
            $this->lasterror = $e->getMessage().' (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>icon</b> = [$icon],<b>adress1</b> = [$adress1],<b>adress2</b> = [$adress2],<b>zipcode</b> = [$zipcode],<b>city</b> = [$city],<b>cityinsee</b> = [$cityinsee],<b>country</b> = [$country],<b>url</b> = [$url],<b>gpslat</b> = [$gpslat],<b>gpslon</b> = [$gpslon],<b>datecreated</b> = [$datecreated]";  
            return false;
        }

    }

    /*
        Insert new reccord into place.
        
        Parameters : fields values list.
        return : True if no error.
    */
    function insert( $name,$description,$private,$icon,$adress1,$adress2,$zipcode,$city,$cityinsee,$country,$url,$gpslat,$gpslon,$datecreated ) {

        $this->lasterror="";
        $this->lastInsertId = -1;

		if ($name == '') $name = null;
		if ($description == '') $description = null;
		if ($private == '') $private = null;
		if ($icon == '') $icon = null;
		if ($adress1 == '') $adress1 = null;
		if ($adress2 == '') $adress2 = null;
		if ($zipcode == '') $zipcode = null;
		if ($city == '') $city = null;
		if ($cityinsee == '') $cityinsee = null;
		if ($country == '') $country = null;
		if ($url == '') $url = null;
		if ($gpslat == '') $gpslat = null;
		if ($gpslon == '') $gpslon = null;
		if ($datecreated == '') $datecreated = null;
		
		
        if ($this->checkValue( array( 
		$name => '',
		$description => '',
		$private => '',
		$icon => '',
		$adress1 => '',
		$adress2 => '',
		$zipcode => '',
		$city => '',
		$cityinsee => '',
		$country => '',
		$url => '',
		$gpslat => '',
		$gpslon => '',
		$datecreated => ''

) ) == false )
        {
            $this->lasterror="Check fields error";        
            return false;
        }

        $sqlSt="
		insert into place (
		name,
		description,
		private,
		icon,
		adress1,
		adress2,
		zipcode,
		city,
		cityinsee,
		country,
		url,
		gpslat,
		gpslon,
		datecreated
 
			)
		values (
		:name, 
		:description, 
		:private, 
		:icon, 
		:adress1, 
		:adress2, 
		:zipcode, 
		:city, 
		:cityinsee, 
		:country, 
		:url, 
		:gpslat, 
		:gpslon, 
		:datecreated 
 
			);    
            ";

        try {        

            $stmt = $this->db->prepare($sqlSt);               
			
			$stmt->bindParam(':name', $name, PDO::PARAM_STR); 
			$stmt->bindParam(':description', $description, PDO::PARAM_STR); 
			$stmt->bindParam(':private', $private, PDO::PARAM_INT); 
			$stmt->bindParam(':icon', $icon, PDO::PARAM_STR); 
			$stmt->bindParam(':adress1', $adress1, PDO::PARAM_STR); 
			$stmt->bindParam(':adress2', $adress2, PDO::PARAM_STR); 
			$stmt->bindParam(':zipcode', $zipcode, PDO::PARAM_STR); 
			$stmt->bindParam(':city', $city, PDO::PARAM_STR); 
			$stmt->bindParam(':cityinsee', $cityinsee, PDO::PARAM_INT); 
			$stmt->bindParam(':country', $country, PDO::PARAM_STR); 
			$stmt->bindParam(':url', $url, PDO::PARAM_STR); 
			$stmt->bindParam(':gpslat', $gpslat, PDO::PARAM_STR); 
			$stmt->bindParam(':gpslon', $gpslon, PDO::PARAM_STR); 
			$stmt->bindParam(':datecreated', $datecreated, PDO::PARAM_STR); 
 

            $stmt->execute();     
            $this->lastInsertId = $this->db->lastInsertId(); 
            
            if ($stmt->rowCount() == 0) {
				$this->lasterror = 'Erreur Sql insert'.'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>icon</b> = [$icon],<b>adress1</b> = [$adress1],<b>adress2</b> = [$adress2],<b>zipcode</b> = [$zipcode],<b>city</b> = [$city],<b>cityinsee</b> = [$cityinsee],<b>country</b> = [$country],<b>url</b> = [$url],<b>gpslat</b> = [$gpslat],<b>gpslon</b> = [$gpslon],<b>datecreated</b> = [$datecreated]";
				return false;
			}              
                   
            return true;

        } catch (Exception $e) {
             $this->lasterror = $e->getMessage().'  (<b>Id</b> = '.$id.'). <b>Sqlst</b> = ['.$sqlSt.'] values : '."<b>name</b> = [$name],<b>description</b> = [$description],<b>private</b> = [$private],<b>icon</b> = [$icon],<b>adress1</b> = [$adress1],<b>adress2</b> = [$adress2],<b>zipcode</b> = [$zipcode],<b>city</b> = [$city],<b>cityinsee</b> = [$cityinsee],<b>country</b> = [$country],<b>url</b> = [$url],<b>gpslat</b> = [$gpslat],<b>gpslon</b> = [$gpslon],<b>datecreated</b> = [$datecreated]";
            return false;
        }
    }

    /*
        Delete one reccord from place.
        
        parameters : $id (reccord id).
        return : True if no error.
    */
    function delete($id) {

        $this->lasterror="";

        $sqlSt="
		delete from place             
		where id = :id; 
            ";   
     
        try {        

            $stmt = $this->db->prepare($sqlSt);  
            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();        
            
			if ($stmt->rowCount() == 0) {
				$this->lasterror = "Erreur Sql delete ".' (<b>Id</b> ='.$id.')';       
				return false;
			}              

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage().' (<b>Id</b>='.$id.')';
            return false;
        }
        return true;
    }

    /*
        Get id min, id max, record count from place  
        
        parameters : None
        return : count value or False in case of error
    */
	function getCount() {
		
        $this->lasterror="";

        $sqlSt="
		select min(id) as minid, max(id) as maxid, count(*) as count 
		from place 
                ";

        try {        

            $stmt = $this->db->prepare($sqlSt);        
            $stmt->execute(); 
            $results = $stmt->fetchAll(PDO::FETCH_ASSOC); 
            return $results[0];          

        } catch (Exception $e) {
            $this->lasterror = $e->getMessage();
            return array( 'minid' => -1, 'maxid' => -1, 'count' => -1);
        }
        		
		//return $this->count;
		return $results[0];
	}




	public $colmeta = [
	'a.id' => array (
		'metades' => "id",
		'sortformat' => "{{sortformat}}",
		'listlen' => 4,
		'listlib' => 'id',
		'listlink' => 'on',
		'selectlen' => 4,
		'selectlib' => 'id',
		'selectlink' => 'on',
		'selectdisplay' => '',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => '', 
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 

		),
	'a.name' => array ( 
		'metades' => "name",
		'sortformat' => "", 
		'listlen' => 25,
		'listlib' => 'name' , 
		'listlink' => '',
		'selectlen' => 25,
		'selectlib' => 'name' , 
		'selectlink' => 'on',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.description' => array ( 
		'metades' => "description",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'description' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'description' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.private' => array ( 
		'metades' => "private",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'private' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'private' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.icon' => array ( 
		'metades' => "icon",
		'sortformat' => "", 
		'listlen' => 4,
		'listlib' => 'icon' , 
		'listlink' => '',
		'selectlen' => 4,
		'selectlib' => 'icon' , 
		'selectlink' => '',
		'selectdisplay' => 'urlpic',
		'selectdisplaywidth' => '50', 
		'selectdisplayheight' => '50', 
		'listdisplay' => 'urlpic',
		'listdisplaywidth' => '50', 
		'listdisplayheight' => '50' 
),
	'a.adress1' => array ( 
		'metades' => "adress1",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'adress1' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'adress1' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.adress2' => array ( 
		'metades' => "adress2",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'adress2' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'adress2' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.zipcode' => array ( 
		'metades' => "zipcode",
		'sortformat' => "", 
		'listlen' => 5,
		'listlib' => 'zipcode' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'zipcode' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.city' => array ( 
		'metades' => "city",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'city' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'city' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.cityinsee' => array ( 
		'metades' => "cityinsee",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'cityinsee' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'cityinsee' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.country' => array ( 
		'metades' => "country",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'country' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'country' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.url' => array ( 
		'metades' => "",
		'sortformat' => "", 
		'listlen' => 12,
		'listlib' => 'url' , 
		'listlink' => '',
		'selectlen' => 12,
		'selectlib' => 'url' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.gpslat' => array ( 
		'metades' => "gpslat",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'Lat' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'gpslat' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.gpslon' => array ( 
		'metades' => "gpslon",
		'sortformat' => "", 
		'listlen' => 0,
		'listlib' => 'Lon' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'gpslon' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
),
	'a.datecreated' => array ( 
		'metades' => "datecreated",
		'sortformat' => "date", 
		'listlen' => 0,
		'listlib' => 'datecreated' , 
		'listlink' => '',
		'selectlen' => 0,
		'selectlib' => 'datecreated' , 
		'selectlink' => '',
		'selectdisplay' => 'text',
		'selectdisplaywidth' => '0', 
		'selectdisplayheight' => '0', 
		'listdisplay' => 'text',
		'listdisplaywidth' => '0', 
		'listdisplayheight' => '0' 
)

			
	];

    /*
        Get field property value
        
        Parameters : field name and property name.
        return : value of property.
    */

	function getMeta( $fieldkey , $metakey ) {
		return $this->colmeta [$fieldkey][$metakey];
	}

    /*
        Get labels for list table header.
        
        Parameters : None.
        return : String.
    */

	function getTableHeaderList() {		
		
		$labelsStr ='';
		
		foreach (  $this->colmeta as $k => $v) {
			if ( $v['listlen'] > 0 ) 
				$labelsStr = $labelsStr.'<th title="'.$v['metades'].'" >'.$v['listlib'] .'</th>'."\n";
		}				
		return $labelsStr;
	}
	
	function getTableFieldLenList( $field ) {		
		
		return $this->colmeta[$field]['listlen'];
	}

	function getTableFieldLinkList( $field ) {		
		
		return $this->colmeta[$field]['listlink'];
	}

    /*
        Get labels for select table header.
        
        Parameters : None.
        return : String.
    */

	function getTableHeaderSelect() {		
		
		$labelsStr ='';
		
		foreach (  $this->colmeta as $k => $v) {
			if ( $v['selectlen'] > 0 ) 
				$labelsStr = $labelsStr.'<th title="'.$v['metades'].'" >'.$v['selectlib'] .'</th>'."\n";
		}				
		return $labelsStr;
	}
	
	function getTableFieldLenSelect( $field ) {		
		
		return $this->colmeta[$field]['selectlen'];
	}

	function getTableFieldLinkSelect( $field ) {		
		
		return $this->colmeta[$field]['selectlink'];
	}

	
    /*
        Check user input values for place.
        
        Parameters : array of fields with regexp  paterns. ex: array( $nom =>'^(?!\s*$).+' , $icone => '')
        return : False if at last one regexp does not match.
    */
    function checkValue( $arrayCheck ) {

        $indexfield=1;
        foreach ( $arrayCheck as $value => $pattern) {

            if ($pattern=='') continue;

            $pattern='/'.$pattern.'/';

            if (!preg_match($pattern, $value)) {
                $this->lasterror = "Erreur champ #".$indexfield. '. Valeur:['.$value.']';
                return false;                
            }

            $indexfield+=1;

        }

        return true;
    }

} // end class

?>
