<?php

/*
 
        Contenu table : event_source.

        07/03/2021 10:45

        lvardon@laposte.net - 2021
         
        Licence libre

*/

?> 

<!DOCTYPE html>
<html lang="fr">
  <head>
    <meta charset="utf-8">
    <title></title>

    <link rel="stylesheet" href="css/page.css">
    <link rel="stylesheet" href="css/menu.css">
    <link rel="stylesheet" href="css/field.css"> 
    
    <script type="text/javascript" src="//code.jquery.com/jquery-1.11.3.min.js"></script>
    <script type="text/javascript" charset="utf8" src="js/DataTables/datatables.js"></script>
    <link rel="stylesheet" href="js/DataTables/datatables.min.css"> 

    <link rel="stylesheet" href="https://unpkg.com/purecss@2.0.3/build/pure-min.css" integrity="sha384-cg6SkqEOCV1NbJoCu11+bm0NvBRc8IYLRGXkmNrqUBfTjmMYwNKPWBTIKyw9mHNJ" crossorigin="anonymous">

	<link rel="stylesheet" href="css/icons/css-file-icons.css" />

    <script type="text/javascript">

		$(document).keyup(function(e) {
			 if (e.keyCode == 27) { 
				stopModal('selectplaceholder');			
				$('#selectplaceholder').empty();
			}
		});			

        $(document).ready(function() {
			
            $('#datatableselect').DataTable( {
                xautoWidth: false,
                xcolumnDefs: [
                    { "width": "10px", "targets": [0] },       
                    { "width": "20px", "targets": [1] }
                  ] ,             
                  
				"drawCallback": function( settings ) {
					
						$(".selectlistitem").on("click", function() {
							
							stopModal('selectplaceholder');			
							$('#selectplaceholder').empty();
							//alert( "2 valuebackval = [<?php echo $_REQUEST['valuebackval']; ?>]" + " lib back (valueval) = [" + $(this).attr('valueval') + "]");							
							<?php 
								echo "$('#".$_REQUEST['valuebackfield']."').val( $(this).attr('valueid') );";
								echo "$('#".$_REQUEST['valuebackval']."').val( $(this).attr('valueval') );"; 
							?>										
						});
						
						$("#selectclose").on("click", function() {
							stopModal('selectplaceholder');		
							$('#selectplaceholder').empty();	
						});
						
				},                  
                     
                language: {
                            "sEmptyTable":     "Aucune donnée disponible dans le tableau",
                            "sInfo":           "Affichage de l'élément _START_ à _END_ sur _TOTAL_ éléments",
                            "sInfoEmpty":      "Affichage de l'élément 0 à 0 sur 0 élément",
                            "sInfoFiltered":   "(filtré à partir de _MAX_ éléments au total)",
                            "sInfoPostFix":    "",
                            "sInfoThousands":  ",",
                            "sLengthMenu":     "Afficher _MENU_ éléments",
                            "sLoadingRecords": "Chargement...",
                            "sProcessing":     "Traitement...",
                            "sSearch":         "Rechercher :",
                            "sZeroRecords":    "Aucun élément correspondant trouvé",
                            "oPaginate": {
                                "sFirst":    "Premier",
                                "sLast":     "Dernier",
                                "sNext":     "Suivant",
                                "sPrevious": "Précédent"
                            },
                            "oAria": {
                                "sSortAscending":  ": activer pour trier la colonne par ordre croissant",
                                "sSortDescending": ": activer pour trier la colonne par ordre décroissant"
                            },
                            "select": {
                                    "rows": {
                                        "_": "%d lignes sélectionnées",
                                        "0": "Aucune ligne sélectionnée",
                                        "1": "1 ligne sélectionnée"
                                    } 
                            }
                }

            } );

            $("#menu_<?php if (isset( $_REQUEST['table'])) echo $_REQUEST['table']; else echo ''; ?>").addClass("nav_current");

        } );

    </script>
  </head>
  <body>
	  
<?php

chdir('..');

include_once "dbconnect.php";
include_once "phpdb/class_event_source.php";
include_once "phpdb/class_event_source_ext.php";

// Class instance
$myevent_source = new event_source( $db );

// Select all reccords :
$results = $myevent_source->selectAll();
if ($results === false) {
	echo "Erreur : ".$myevent_source->lasterror."<br>";
}

echo '<div style="margin-left:1%; margin-right:1%"" >';
echo '<div style="display:inline-block;" class="titleedit">Sélection: <span title="Association des &eacute;v&eacute;nements aux sources" class="titleedit">Even. source</div>';
echo '<div style="float:right; display:inline-block; cursor: pointer" id="selectclose">X</div>';

?>

<table id="datatableselect" class="display" cellspacing="0" xwidth="85%">

    <thead>

        <tr>            
             <?php echo $myevent_source->getTableHeaderSelect(); ?>
        </tr>

    </thead>

    <tbody>

<?php

foreach($results as $row) {

	$rowkeyvalue=$row['a.id'];

    echo "\n";   
    echo '<tr>';

    foreach($row as $key => $value) {

		$fieldLen = $myevent_source->getTableFieldLenSelect( $key );
			if ( $fieldLen == 0 )
				continue;
        
        echo '<td>';

        $datafollow="";    
        $dataDisplay=$value;
        if ( strlen($value) > $fieldLen ) {
            $datafollow="...";     
            $dataDisplay=mb_substr($value, 0, $fieldLen);
        }
		
        if ( $myevent_source->getTableFieldLinkSelect( $key ) == 'on' )
            echo '<a title="'.$value.'" class="selectlistitem" valueid="'.$rowkeyvalue.'" valueval="'.$row['a.id'].'" href="#" >'.$dataDisplay.$datafollow.'</a>';        
        else 
			switch ($myevent_source->getMeta($key , 'selectdisplay')) {
			  case 'color':    
				echo '<span style="display:none" >'.$value.'</span>';
				$iconwidth = $myevent_source->getMeta($key , 'listdisplaywidth');
				$iconheight = $myevent_source->getMeta($key , 'listdisplayheight');				
				echo '<div title="'.$value.'" style="height:0;width:'.$iconwidth.'%;padding-bottom:'.$iconheight.'%;background-color:'.$value.'">';
				break;
								
			  case 'urlpic':    
				$iconwidth = $myevent_source->getMeta($key , 'selectdisplaywidth');
				$iconheight = $myevent_source->getMeta($key , 'selectdisplayheight');
				if ( file_exists($value) )
					echo '<img alt="'.$value.'" title="'.$value.'" src="'.$value.'" width='.$iconwidth.' height='.$iconheight.'>';
				else
					echo '<img alt="image inexistante" title="image inexistante" src="img/missing.png" width='.$iconwidth.' height='.$iconheight.'>';			  
				break;
				
			  case 'url':
					echo '<a title="'.$value.'" href="'.$value.'" target="_blank" >'.$dataDisplay.$datafollow.'</a>';				
				break;

			case 'icondoc':    
				if (file_exists($value)) {
					$ext = pathinfo($value, PATHINFO_EXTENSION); 
					echo '<a href="'.$value.'">';
					echo '<div class="fi fi-'.$ext.'">
						<div title="'.$value.'" class="fi-content">'.$ext.'</div>
					</div>';
					echo '</a>';
				}			
				break;	

				
			  default:
			    if ($myevent_source->getMeta($key , 'sortformat') == 'date') {
					$sortData = substr($value, 6,4) . substr($value, 3,2) . substr($value, 0,2) ; // database : dd/mm/yyyy 
					echo '<span style="display:none" >'.$sortData.'</span>'.'<div title="'.$value.'">'.$dataDisplay.$datafollow.'</div>';
				}
				else
					echo '<div title="'.$value.'">'.$dataDisplay.$datafollow.'</div>';

			}

        echo '</td>';
        echo "\n";
    }
    echo '</tr>';    
} 

?>

    </tbody>

</table>

</div>


<script type="text/javascript">

	function stopModal(id) {
		if ($("#PopupMask") == null) return;
		$("#PopupMask").remove();
		$("#"+id).css( "z-index" , $("#"+id).data('saveZindex') );
		$("#"+id).css( "position" , $("#"+id).data('savePosition') );
	}

</script>

  </body>
</html>
